﻿

using CallCenter.Caches;
using CallCenter.Notifications;
using CallCenter.Realtimes;
using CallCenter.Share.Enums;
using CallCenter.Share.Notifications;
using MediatR;

namespace CallCenter.Application.Handlers.FlowControl
{
    public class ByeExtAndExtNotificationHandler : INotificationHandler<ByeExtAndExtNotification>
    {

        private readonly IRealtimeService _realtimeService;
        private readonly IUserCacheManager _userCacheManager;

        public ByeExtAndExtNotificationHandler(IRealtimeService realtimeService, IUserCacheManager userCacheManager)
        {
            _realtimeService = realtimeService;
            _userCacheManager = userCacheManager;
        }

        public async Task Handle(ByeExtAndExtNotification notification, CancellationToken cancellationToken)
        {
            //通知前端主叫
            //获取主叫工作信息
            var fromWork = _userCacheManager.GetWorkByTel(notification.FromTelNo);
            if (fromWork != null)
            {
                await _realtimeService.ByeAsync(fromWork.UserId, new ByeDto() { Id = notification.FromTelNo }, cancellationToken);
            }
            //通知前端被叫
            var toWork = _userCacheManager.GetWorkByTel(notification.ToTelNo);
            if (toWork != null)
            {
                await _realtimeService.ByeAsync(toWork.UserId, new ByeDto() { Id = notification.ToTelNo}, cancellationToken);
            }
        }
    }
}
